=== pkg/debian/changelog ===
rvault (0.0.1) unstable; urgency=medium

  * Initial release.

 -- rmind <rmind@noxt.eu>  Fri, 20 Dec 2019 18:00:00 +0200
