=== pkg/debian/control ===
Source: rvault
Priority: extra
Maintainer: https://github.com/rmind
Build-Depends:
 debhelper (>= 9),
 make,
 libssl-dev,
 libscrypt-dev,
 libfuse-dev,
 libcurl4-dev,
 libedit-dev,
 libsqlite3-dev
Standards-Version: 3.9.1
Homepage: https://github.com/rmind/rvault
License: BSD-2-clause

Package: rvault
Section: misc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure and authenticated store for secrets and small documents
  rvault is a secure and authenticated store for secrets (passwords,
  keys, certificates) and small documents.  It uses _envelope encryption_
  with one-time password (OTP) authentication.  It is written in C11 and
  distributed under the 2-clause BSD license.

Package: rvault-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, rvault (= ${binary:Version})
Description: Debug symbols for rvault
 Debug symbols for rvault.
